"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.trifleBeet = exports.Trifle = void 0;
const web3 = __importStar(require("@solana/web3.js"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
const beet = __importStar(require("@metaplex-foundation/beet"));
const Key_1 = require("../types/Key");
const TokenAmount_1 = require("../types/TokenAmount");
class Trifle {
    constructor(key, tokenEscrow, tokens, escrowConstraintModel, padding) {
        this.key = key;
        this.tokenEscrow = tokenEscrow;
        this.tokens = tokens;
        this.escrowConstraintModel = escrowConstraintModel;
        this.padding = padding;
    }
    static fromArgs(args) {
        return new Trifle(args.key, args.tokenEscrow, args.tokens, args.escrowConstraintModel, args.padding);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return Trifle.deserialize(accountInfo.data, offset);
    }
    static async fromAccountAddress(connection, address, commitmentOrConfig) {
        const accountInfo = await connection.getAccountInfo(address, commitmentOrConfig);
        if (accountInfo == null) {
            throw new Error(`Unable to find Trifle account at ${address}`);
        }
        return Trifle.fromAccountInfo(accountInfo, 0)[0];
    }
    static gpaBuilder(programId = new web3.PublicKey('trifMWutwBxkSuatmpPVnEe7NoE3BJKgjVi8sSyoXWX')) {
        return beetSolana.GpaBuilder.fromStruct(programId, exports.trifleBeet);
    }
    static deserialize(buf, offset = 0) {
        return exports.trifleBeet.deserialize(buf, offset);
    }
    serialize() {
        return exports.trifleBeet.serialize(this);
    }
    static byteSize(args) {
        const instance = Trifle.fromArgs(args);
        return exports.trifleBeet.toFixedFromValue(instance).byteSize;
    }
    static async getMinimumBalanceForRentExemption(args, connection, commitment) {
        return connection.getMinimumBalanceForRentExemption(Trifle.byteSize(args), commitment);
    }
    pretty() {
        return {
            key: 'Key.' + Key_1.Key[this.key],
            tokenEscrow: this.tokenEscrow.toBase58(),
            tokens: this.tokens,
            escrowConstraintModel: this.escrowConstraintModel.toBase58(),
            padding: this.padding,
        };
    }
}
exports.Trifle = Trifle;
exports.trifleBeet = new beet.FixableBeetStruct([
    ['key', Key_1.keyBeet],
    ['tokenEscrow', beetSolana.publicKey],
    ['tokens', beet.map(beet.utf8String, beet.array(TokenAmount_1.tokenAmountBeet))],
    ['escrowConstraintModel', beetSolana.publicKey],
    ['padding', beet.uniformFixedSizeArray(beet.u8, 32)],
], Trifle.fromArgs, 'Trifle');
//# sourceMappingURL=Trifle.js.map